/* 
 ******************************************************************
 * $Id: ma2asm.h,v 1.15 2004/03/04 14:29:28 clerger Exp $
 * Copyright (C) 1998, 2002, 2004 by INRIA 
 * Author: Eric de la Clergerie <Eric.De_La_Clergerie@inria.fr>
 * ----------------------------------------------------------------
 *
 *  dyam2ma.h -- 
 *
 * ----------------------------------------------------------------
 * Description
 * 
 * ----------------------------------------------------------------
 */

#define Check_Arg(i,str)      (strncmp(argv[i],str,strlen(argv[i]))==0)

#define MA2ASM_VERSION             "1.0"
#define DEFAULT_OUTPUT_SUFFIX      ".s"

#define MASK_LONG_GLOBAL           1
#define MASK_LONG_INITIALIZED      2

extern buffer auxbuf;
extern int    in_ident;

typedef struct InitLongList 
{
    int type;                   /* 0=ident 1=number */
    long value;
    struct InitLongList *next;
} InitLongList, *InitLongList_t;

/*---------------------------------*/
/* Function Prototypes             */
/*---------------------------------*/

void      Declare_Initializer   (char *initializer_fct);
void      Data_Long             (char *name,int global,long length,InitLongList_t value);

InitLongList_t Init_Long_Add   (short type, long value, InitLongList_t next);

          /* from os_cpu.c files */

void      Source_Line           (int line_no,char *cmt);

void      File_Name             (char *file_name);

void      Asm_Start             (void);
void      Asm_Stop              (void);

void      Code_Start            (char *label,int prolog,int global);
void      Code_Stop             (void);

void      Label                 (char *label);

void      Pl_Jump               (char *label);
void      Pl_Jump_Reg           (char name, int no);
void      Pl_Jump_Star          (void);
void      Pl_Fail               (void);
void      Pl_Ret                (void);

void      Jump                  (char *label);
void      Jump_Not_Zero         (char *label);

void      Move_From_Reg         (char name, int no);
void      Move_To_Reg           (char name, int reg_no);
void      Move_Float_To_Reg     (char name, int reg_no);
void      Move_Int_To_Reg       (int  val_int, char name, int reg_no);
void      Move_Cst_To_Reg       (char cst_kind, int cst_val, char name, int reg_no);

void      Move_Ret_To_Ident     (char *ident,int no);
void      Move_Int_To_Ident     (int  val_int, char *ident, int no);
void      Move_Cst_To_Ident     (char cst_kind, int cst_val, char *ident, int no);

void      Read_Variable         (char *ident,int no);

void      Pl_Call_Start         (char *fct_name,int nb_args);
void      Pl_Call_Stop          (char *fct_name,int nb_args);
void      Pl_Call_Star          (void);
void      Pl_Call_Reg           (char name, int no);
void      Call_C_Start          (char *fct_name,int nb_args);
int       Call_Arg_Label        (int offset,char *ident,int no);
int       Call_Arg_Variable     (int offset,char *ident,int no);
int       Call_Arg_Int          (int offset,int int_val);
int       Call_Arg_Float        (int offset,float flt_val);
int       Call_Arg_Double       (int offset,double dbl_val);
int       Call_Arg_String       (int offset,int str_no);
int       Call_Arg_Reg          (int offset,char name,int no);
int       Call_Arg_Reg_Variable (int offset,char name,int no);
int       Call_Arg_Cst          (int offset, char name,int no);
int       Call_Arg_Param        (int offset, int no);
void      Call_C_Stop           (char *fct_name,int nb_args);
void      Call_C_Adjust_Stack   (int nb_pushes);

void      Jump_Ret              (void);
void      Fail_Ret              (void);
void      Fail_C_Ret            (void);
void      Ret_Not_Zero          (void);
void      C_Ret                 (void);

void      Dico_String_Start     (int nb);
void      Dico_String           (int str_no,char *asciiz);
void      Dico_String_Stop      (int nb);

void      Dico_Long_Start       (int nb);
void      Dico_Long             (char *name,int global,int
                                 initialized,InitLongList_t value, unsigned long length);
void      Dico_Long_Stop        (int nb);

void      True_Ret              (void);
void      True_C_Ret            (void);
int       Add_String            (char *);










