/* 
 ******************************************************************
 * $Id: mapper.c,v 1.3 2002/01/22 13:04:20 clerger Exp $
 * Copyright (C) 1999 by INRIA 
 * Author: Eric de la Clergerie <Eric.De_La_Clergerie@inria.fr>
 * ----------------------------------------------------------------
 *
 *  mapper.c -- Mapper File
 *
 * ----------------------------------------------------------------
 * Description
 *    Include machine specific file for the mini assembler to assembler
 * translator
 *    Inspired from Daniel Diaz GNU Prolog
 * ----------------------------------------------------------------
 */

#include <stdio.h>
#include <stdarg.h>

#include "config.h"             /* in Runtime */
#include "bigloo.h"             /* in Runtime */
#include "archi.h"              /* in Runtime */
#include "fol.h"                /* in Runtime */

#include "buffer.h"
#include "ma2asm.h"

extern int profile;
extern int debug;

void      Label_Printf          (char *label,...);
void      Inst_Printf           (char *op,char *operands,...);
void      VInst_Printf          (char *op,char *operands,va_list arg_ptr);
void      Inst_Out              (char *op,char *operands);

          /* machined-dependent mapper */

#if   defined(M_ix86_linux) || defined(M_ix86_cygwin) 
#include "linux_elf_ix86.c"
#elif defined(M_sparc_sunos) || defined(M_sparc_solaris)
#include "sparc_any.c"
#else
#error "Architecture not yet supported"
#endif


